function [PI RS_train]=PI(S_train,S_test,no_groups,sdim,m,out_g)
red_mode=1;

%Code 0. Dimensionality reduction
%Using PCA or LDA

    %mean/cov computation
    for i=1:no_groups
        me1(:,i)=mean(S_train{i});
        C1(:,:,i)=cov(S_train{i}); %Numerical stabilitity in estimation
    end   
    %mean of all operations
    mean_total= mean(me1,2);
  
    %c_pool used in LDA (before dimensionality reduction)
    c_pool_full = mean(C1,3);
    %c_pool_full = (1/no_inputs)*sum(c_full,3);
        %B used in both PCA, LDA
        B_temp=zeros(size(mean_total,1));
        for i=1:no_groups
            B_temp = B_temp+(me1(:,i)-mean_total)*(me1(:,i)-mean_total)';
        end
        B=(1/no_groups)*B_temp; 
      

    if (red_mode==1) %PCA method
        [U,S,V] = svd(B);
        Ur=U(:,1:m);
    end
    
    if (red_mode==2) %LDA method
       %c1= c_pool_full^(-1/2);
       %[U,S,V] = svd(c1*B*c1);
       [U,S,V] = svd(inv(c_pool_full)*B);
       Ur=U(:,1:m);
    end
    
    %Store Ur
    %projection{1}=Ur;


if (red_mode~=0)
%Code 1. Estimating mean vector and covariance matrix
RS_test=S_test*Ur;

for i=1:no_groups
    RS_train{i}=S_train{i}*Ur;
    me(:,i)=mean(RS_train{i});
    C(:,:,i)=cov(RS_train{i}); 
    %C(:,:,i)=eye(sdim); 
end
C_pool = mean(C,3);
end


if (red_mode==0)
    for i=1:no_groups
    RS_train{i}=S_train{i};
    RS_test{i}=S_test{i};
    me(:,i)=mean(RS_train{i});
    %C(:,:,i)=cov(RS_train{i}); %Numerical stabilitity in estimation
    C(:,:,i)=eye(sdim); 
    end
    C_pool = eye(sdim);

end

%Code 2. Computing the PI(G;S) formula
sum_ext=0;
for g=1:no_groups
    sum_int=0;
    if (g==out_g)
    for t=1:size(RS_test,1) %in leave-one-out the test size is 1
        denom=0;
        for i=1:no_groups
            %no pooled cov matrix
            %denom=denom+mvnpdf(S_test{g}(t,:)',me(:,i),C(:,:,i)); 
            %test set ~= 1
            %denom=denom+mvnpdf(RS_test{g}(t,:)',me(:,i),C_pool); 
            %test set == 1
            denom=denom+mvnpdf(RS_test(t,:)',me(:,i),C_pool); 
        end
        %no pooled cov matrix
        %nom=mvnpdf(S_test{g}(t,:)',me(:,g),C(:,:,g));
        %test set ~= 1
        %nom=mvnpdf(RS_test{g}(t,:)',me(:,g),C_pool);
        %test set == 1
        nom=mvnpdf(RS_test(t,:)',me(:,g),C_pool);
        pr_model=nom/denom;
        sum_int=sum_int+(1/size(RS_test,1))*log2(pr_model);
    end
    sum_ext=sum_ext+sum_int;
    end
end
PI=log2(no_groups)+(1/no_groups) * sum_ext;
end