function success_rate=SR(S,sdim,train_vec,test_vec,m)
%For efficient computation discussion see :
%[https://www.cl.cam.ac.uk/~mgk25/cardis2013-templates.pdf]
comp_mode=2; % 1 for naive probability computation, 2 for Choudary improvemnets ( use 2 )
ch_method=1; % 1 for Choudary MD discriminant, 2 for Choudary LINEAR discriminant
comb_mode=2; % 1 for Averaging attack traces, 2 for using the joint likelihood (1==2 with dLINEAR) Irrelevant here
red_template=0; %set to 1 for reduced template, set to 0 for pooled-cov matrix template
d=1; %number of traces used in detection:highly unlikely that I can increase to d>1 cause it implies another mouse
red_mode=2; % 1 for PCA, 2 for LDA 

no_samples=size(S{1},2); %all samples of the trace
sample_interval=[1:no_samples];  %interval of choice for the full trace
interval_size=sample_interval(length(sample_interval))-sample_interval(1)+1;
%number of intervals in which we perform dimensionality reduction, perhaps
%useful if we want to focus on certain region, e.g. before or after sleep
%deprivation 
no_subintervals=1; 
%Define the chosen intervals here:
sub_int(:,1)=[1,no_samples];
%extra intervals...

%number of groups that we want to distinguish using the SWA
no_inputs=size(S,2); 
for i=1:no_inputs
    train_size(i)=size(train_vec{i},2);  %train set and test set sizes
    test_size(i)=size(test_vec{i},2);
    train_set{i}=S{i}(1:train_size(i),sample_interval); %partitioning to train and test sets
    test_set{i}=S{i}(1:test_size(i),sample_interval);
end

%Dimensionality reduction using PCA or LDA
projection=cell(no_subintervals,1);
for si=1:no_subintervals
    
    clear mean_op; %clear them for every subinterval 
    clear mean_total;
    clear c_full;
    clear c_pool_full;
    
    %mean
    for i=1:no_inputs   
        mean_op(:,i)=mean(train_set{i}(:,sub_int(1,si):sub_int(2,si))); 
    end
    %mean of all operations
    mean_total= mean(mean_op,2);
  
    %c_pool used in LDA (before dimensionality reduction)
    for i=1:no_inputs
        c_full(:,:,i) = cov(train_set{i}(:,sub_int(1,si):sub_int(2,si)));
    end
    c_pool_full = mean(c_full,3);
    %c_pool_full = (1/no_inputs)*sum(c_full,3);
        %B used in both PCA, LDA
        B_temp=zeros(size(mean_total,1));
        for i=1:no_inputs
            B_temp = B_temp+(mean_op(:,i)-mean_total)*(mean_op(:,i)-mean_total)';
        end
        B=(1/no_inputs)*B_temp; 
      

    if (red_mode==1) %PCA method
        [U,S,V] = svd(B);
        Ur=U(:,1:m);
    end
    
    if (red_mode==2) %LDA method
       %c1= c_pool_full^(-1/2);
       %[U,S,V] = svd(c1*B*c1);
       [U,S,V] = svd(inv(c_pool_full)*B);
       Ur=U(:,1:m);
    end
    
    
   %The following scree graph shows the elbow 
   %plot(sum(S));
   %cummulative percentage of total variation
   %delta=sum(S);
   %phi(si)= sum(delta(1:m))/ sum(delta(1:(1:(sub_int(:,2)-sub_int(:,1)+1)))); 
   
   %Store Ur
   projection{si}=Ur;
   
end

%Template Building
for i=1:no_inputs
    full_projected_train=[];
    full_projected_test=[];
    for si=1:no_subintervals
        %project every interval 
        projected_train=(projection{si}'*train_set{i}(:,sub_int(1,si):sub_int(2,si))')';
        projected_test=(projection{si}'*test_set{i}(:,sub_int(1,si):sub_int(2,si))')';
        full_projected_train=horzcat(full_projected_train,projected_train);
        full_projected_test=horzcat(full_projected_test,projected_test);
        
    end
        me(:,i)= mean(full_projected_train,1); %mean after dim reduction
        c(:,:,i) = cov(full_projected_train); %covariance after dim reduction

       set{i}=  full_projected_test;
        
end

c_pool = (1/no_inputs)*sum(c,3); %pooled covariance after dim reduction
inv_c=inv(c_pool); 
    
%Match rate estimation for all groups
for i=1:no_inputs
    counter(i)=0; %counts the misclassified mice
    
    %we can partition the test_set into d-sized components but mostly d=1 
    %I can't think of a case where 2 mouse signals are
    %combined to increase the SR
    for j=1:test_size(i)/d

        %Computing the denominator is NOT necessary 

        %Direct score computation via mvnpdf
        % dFULL + MULT (FULL implies probability computation)
        if (comp_mode==1)
        %legacy code [see old version]
        end
     
        %Choudary improvements
        if (comp_mode==2)
            for k=1:no_inputs

             %mouse-to-classify
        	 trace=set{i}(j,:);
             
             %dMD+AVG
             if (comb_mode==1) &&(ch_method==1)           
                mean_trace=mean(trace);
                p(k)=-0.5*(mean_trace-me(:,k)')*inv_c*(mean_trace-me(:,k)')';
             end
             %dMD+COMB
             if (comb_mode==2)&&(ch_method==1)  
             p(k)=0;
             for index=1:d
                
                 if (red_template==1) %reduced template
                     
                   p(k)=p(k)+(trace(index,:)-me(:,k)')*(trace(index,:)-me(:,k)')';
                 else
                    
                    p(k)=p(k)+(trace(index,:)-me(:,k)')*inv_c*(trace(index,:)-me(:,k)')';
                end
               
            end
            p(k)=-0.5*p(k);
            end
        
            end
        end


        if ((p(i)<max(p))| (max(p)==-Inf)| (max(p)==Inf))    % careful here with Inf
        counter(i)=counter(i)+1;
        end

    end
end

for i=1:no_inputs
    success_rate(i)=1-counter(i)/(test_size(i)/d);
end

success_rate;





end